core::trust::TaggedInteger< Tag, Integer > Struct Template Reference

Helper structure for tagging integer types with certain semantics. More...

`#include <tagged_integer.h>`

Collaboration diagram for core::trust::TaggedInteger< Tag, Integer >:

## Public Types

typedef Tag | TagType
| We bail out if the Integral type is not an integral one. More...
typedef Integer | IntegerType
| Stores the Integer type. More...

## Public Member Functions

| TaggedInteger ()
| Construct an instance with a default value. More...
| TaggedInteger (Integer value)
| Construct an instance from an existing integer type. More...

## Public Attributes

Integer | value
| The contained integer value. More...

## Detailed Description

### template<typename Tag, typename Integer>
struct core::trust::TaggedInteger< Tag, Integer >

Helper structure for tagging integer types with certain semantics.

Definition at line 35 of file tagged_integer.h.

## Member Typedef Documentation

template<typename Tag, typename Integer>

typedef Integer core::trust::TaggedInteger< Tag, Integer >::IntegerType

Stores the Integer type.

Definition at line 43 of file tagged_integer.h.

template<typename Tag, typename Integer>

typedef Tag core::trust::TaggedInteger< Tag, Integer >::TagType

We bail out if the Integral type is not an integral one.

Stores the Tag type.

Definition at line 38 of file tagged_integer.h.

## Constructor & Destructor Documentation

template<typename Tag, typename Integer>

core::trust::TaggedInteger< Tag, Integer >::TaggedInteger | ( |  | ) |

inline

Construct an instance with a default value.

Definition at line 46 of file tagged_integer.h.

template<typename Tag, typename Integer>

core::trust::TaggedInteger< Tag, Integer >::TaggedInteger | ( | Integer | value | ) |

inline explicit

Construct an instance from an existing integer type.

Definition at line 51 of file tagged_integer.h.

## Member Data Documentation

template<typename Tag, typename Integer>

Integer core::trust::TaggedInteger< Tag, Integer >::value

The contained integer value.

Definition at line 56 of file tagged_integer.h.

Referenced by core::trust::operator!=(), core::trust::operator<(), and core::trust::operator==().

The documentation for this struct was generated from the following file:

- /build/trust-store-uD3f_u/trust-store-2.0.0+16.04.20160119/include/core/trust/tagged_integer.h